<template>
    <v-select
        v-model="localValue"
        item-text="name"
        item-value="id"
        :items="brands"
        :loading="loading"
        :placeholder="placeholder"
        :error-messages="errors"
        hide-selected
        chips
        deletable-chips
        outlined
        :menu-props="{ bottom: true, offsetY: true }"
    >
    </v-select>
</template>

<script>
    export default {
        name: "VBusinessTypeSelect",
        props: {
            value: {
                validator: val => typeof val === 'number' || val === null
            },
            errors: [String, Array],
            placeholder: {
                type: String,
                default: ''
            },
            hideDetails: {
                type: [Boolean, String],
                default: false
            },
            clearable: {
                type: Boolean,
                default: false
            }
        },

        data: () => ({
            loading: true,
            brands: []
        }),

        computed: {
            localValue: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('input', val);
                }
            }
        },

        mounted() {
            this.fetchBusinessTypes()
                .then(data => {
                    this.loading = false;
                    this.brands = data;
                })
                .catch(error => {
                    this.loading = false;
                    console.error('Request failed.', error);
                });
        },

        methods: {
            fetchBusinessTypes() {
                return new Promise((resolve, reject) => {
                    axios.get('api/business-types')
                        .then(({ data }) => {
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                });
            }
        }
    }
</script>

<style scoped>

</style>
